#include <bits/stdc++.h>
using namespace std;

int main()
{
	int n,k,c,uk=0,i,j,cc;
	
	cin>>n>>k>>c;   // UNOS N K C - NIZ PODNIZ C - maks vrednost c
	int niz[n];
	cc=c;
	for(i=0;i<n;i++)
	{
		cin>>niz[i];
	}                     // UNOS NIZA
	
	
	//koliko imam podnizova - n-k+1 - toliko puta ponavljam
	for(i=0;i<n-k+1;i++)
	{
		uk=0;
		c=1;
		for(j=i;j<i+3;j++)
		{
			uk=uk+c*niz[j];
			if((niz[j]<0)&&(cc>c))
			{
				c++;
			}
			
		}
		cout<<uk<<" ";
	}
}